#include <targets/LPC213x.h>
#include "1wire.h"

#define PINn 1<<12
#define WIRE(bit) if (bit) IO0SET=PINn; else IO0CLR=PINn;
#define coe 1

/*
void WIRE(int arg) 
 {
 if(arg==1)
 {
  IO0DIR|=(1 << PINn);
  IO0SET=(1 << PINn);
  // IO0SET=0x16;
 }
 else if(arg==0) 
 { 
  IO0DIR|=(1 << PINn);;
  IO0CLR=(1 << PINn);
 // IO0CLR=0x16;
 }
 }*/

void wire_init(void)
{
  // PIN as output
    IO0DIR |= PINn;
    wire_out();
}

void wire_out(void)
{
  // PIN as output
    IO0DIR |= PINn;
    IO0SET = PINn;     
}

void wire_in(void)
{
  // PIN as input
    IO0DIR &= ~PINn;
}

unsigned char wire_reset(void)
{
  unsigned short int present;

  wire_out();
  WIRE(0);
  delay(700*coe);//700
  WIRE(1);
  wire_in();
  delay(5*coe);
  present = IO0PIN & PINn;
  delay(400*coe);
  wire_out();

  return !present;
}

void wire_tx(unsigned char bit)
{
  wire_out();
  WIRE(0);

  if (bit&1)
  {
    //delay(10*coe);
    WIRE(1);
    delay(5*coe);
  }
  else
  {
    delay(5*coe);
    WIRE(1);
    //delay(10*coe);
  }
}

void wire_send(unsigned char data)
{
  unsigned char l;
  l = 8;
  
  do
  {
    wire_tx(data&1);
    data>>=1;
  }
  while (--l);
}

unsigned char wire_rx(void)
{
  unsigned short int bit;

  wire_out();
  delay(2*coe);
  WIRE(0);
  //delay(10*coe);
  WIRE(1);
  wire_in();
  //delay(10*coe);

  bit = IO0PIN & PINn;
  if (!bit)
  {
    delay(5*coe);
  }
  wire_out();
  return (bit)?1:0;
}
