/***********************************************************

                    1-Wire demonstration

      Connections:
        (1-Wire)
        P0.12 to 1-W
        1-WIRE connector to DALLAS DS1820 type digital thermometer

        (LCD)
        P0.16 to D4
        P0.17 to D5
        P0.18 to D6
        P0.19 to D7
        P0.20 to RS
        P0.21 to E
        CONTRAST TO Vc
        +5V TO LGT

 ***********************************************************/

#include <targets/LPC213x.h>
#include "lcd.h"
#include "1wire.h"
//#include "delay.c"

#define DATAFLASH    1
#define WIRE         0

unsigned char state, l, temp, remain, test_result;
char temp_txt[]="Temp= xx.xxxx\xdf\x43",d=0;
float f_t;

int
main(void)
{

VPBDIV=0x01;
int s;
char a[20],t;
int poz[2];
//FrecInit();
state = WIRE;
wire_init();

t=wire_reset();

LcdInit();
LcdClear();

  if (!t)
  {
    
    LcdSetCursor(0x00);
    LcdPrint(" Test MMlpc213x ");
    LcdSetCursor(0x40);
    LcdPrint("No 1-Wire device");
    
  }
  else
  {
    
    LcdSetCursor(0x00);
    LcdPrint(" Test MMlpc213x ");
    LcdSetCursor(0x40);
    LcdPrint("1-Wire detected");
    

    test_result |= 1<<WIRE;  
    while(1)
    {
      wire_reset();
      wire_send(0xCC); //Master issues Skip ROM command.
      wire_send(0x44); //Master issues Convert T command.
      //delay(100000); //750ms
      if (wire_reset())
      {
        wire_send(0xCC); //Master issues Skip ROM command.
        wire_send(0xBE); //Master issues Read Scratchpad command.
        l = 16; //read temperature
        temp = 0x0; 
        do
        {      
          temp |= wire_rx()<<(16-l);
        }
        while (--l);

        l = 4*8; //skip some data
        do
        {      
          wire_rx();
        }
        while (--l);

        l = 8; //read count remain
        remain = 0x0;
        do
        {      
          remain |= wire_rx()<<(8-l);
        }
        while (--l);


        if (temp&0x8000) //temp ujemna
        {
          temp = ~temp+1;
          temp_txt[5]='-';
        }
        else // temp dodatnia
          temp_txt[5]=' ';


        //High Resolution Temperature Measurement
        f_t=(temp>>1) - 0.25 + (16-remain)/(float)16;

        l = f_t/10;
       
        temp_txt[6]='0'+l;
        l = (int)f_t%10;
        temp_txt[7]='0'+l;
        l = (int)(f_t*10)%10;
        temp_txt[9]='0'+l;
        l = (int)(f_t*100)%10;
        temp_txt[10]='0'+l;
        l = (int)(f_t*1000)%10;
        temp_txt[11]='0'+l;
        l = (int)(f_t*10000)%10;
        temp_txt[12]='0'+l;


      }

LcdInit();
LcdClear();
LcdSetCursor(0x0);
LcdPrint("Dallas  DS1820");
LcdSetCursor(0x40);
LcdPrint(temp_txt);
      
    }
}


    while(1);

return 0;    
}





