/***********************************************************

                    1-Wire demonstration

      Connections:
        (LCD)
        P0.16 to D4
        P0.17 to D5
        P0.18 to D6
        P0.19 to D7
        P0.20 to RS
        P0.21 to E
        CONTRAST TO Vc
        +5V TO LGT

 ***********************************************************/
#include <targets/LPC213x.h>
#include "lcd.h"
#include "spi.h"

//#include "delay.c"

#define DATAFLASH    1
#define WIRE         0

unsigned char state, l, temp, remain, test_result;
char temp_txt[]="Temp= xx.xxxx\xdf\x43", flash_rx[8], flash_tx[8]="123Text";
char chars[]={0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 
              0x00, 0x11, 0x0A, 0x04, 0x0A, 0x11, 0x00, 0x00, //x
              0x00, 0x00, 0x01, 0x02, 0x14, 0x08, 0x00, 0x00, //v
              0x00, 0x00, 0x00, 0x00, 0x1f, 0x1f, 0x1f, 0x1f, 
              0x00, 0x00, 0x00, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 
              0x00, 0x00, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 
              0x00, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 
              0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f};


float f_t;

int
main(void)
{

VPBDIV=0x01;
int s;
char a[20],t,W=0,F=0;
int poz[2];
//FrecInit();

LcdInit();
LcdClear();
LcdSetCursor(0x0);
 LcdPrint("   MMlpc2138 ");


  state = DATAFLASH;

  SPI_Init();
  AT45_Reset();


//PCONP=0x0;
//SPCCR = 0x0;
//SPCR = 0x0;;  //master SPCR = 0x0;
//PINSEL0=0x0;
//delay(100);


LcdInit();
  LcdClear();
  LcdPrint(" Test Dataflash ");
  LcdSetCursor(0x40);
  
  test_result |= 1<<DATAFLASH;
 delay(10000);
  switch (AT45_DetectDevice())
  {
    case AT1M   : LcdPrint("Atmel AT45DB011 "); break;
    case AT2M   : LcdPrint("Atmel AT45DB021 "); break;
    case AT4M   : LcdPrint("Atmel AT45DB041 "); break;
    case AT8M   : LcdPrint("Atmel AT45DB081 "); break;
    case AT16M  : LcdPrint("Atmel AT45DB161 "); break;
    case AT32M  : LcdPrint("Atmel AT45DB321 ");  break;
    case AT64M  : LcdPrint("Atmel AT45DB642 "); break;
    case AT128M : LcdPrint("  Atmel AT128M  "); break;
    case AT256M : LcdPrint("  Atmel AT256M  "); break;
    case AT512M : LcdPrint("  Atmel AT512M  "); break;
    default: test_result &= ~(1<<DATAFLASH); LcdPrint("Unknown device! ");
  }  
  delay(500000);

  if (test_result & (1<<DATAFLASH))
  {
    LcdSetCursor(0x40);    
    
  
    AT45_MainMemoryProgram(1, 0, flash_tx , 8);
    
    AT45_ContinousArrayRead(0, flash_rx, 8);
    
    AT45_PageErase(0);


    temp = 7;
    while (temp && (flash_tx[temp] == flash_rx[temp--]));

    if (temp>0)
    {
      test_result &= ~(1<<DATAFLASH);
      LcdPrint("Memory write:OK!");
      F=1;
    }
    else
      LcdPrint("Write FAILED!");

}

while(1);
return 0;    
}





