#include <targets/LPC213x.h>


/*//SPI_MR bits
#define PCS3      0x80000
#define PCS2      0x40000
#define PCS1      0x20000
#define PCS0      0x10000
#define LLB       0x00080
#define MODFDIS   0x00010
#define FDIV      0x00008
#define PCSDEC    0x00004
#define PS        0x00002
#define MSTR      0x00001

//SPI_CR bits
#define LASTXFER  0x1000000
#define SWRST     0x0000080
#define SPIDIS    0x0000002
#define SPIEN     0x0000001

//SPI_CSR1 bits
#define DLYBCT    24
#define DLYBS     16
#define SCBR      8
#define BITS      0x10
#define CSAAT     0x8
#define NCPHA     0x2
#define CPOL      0x1

//PIOA peripheral pins
#define MISO      1<<12//0x00000800
#define MOSI      1<<13//0x00001000
#define SPCK      1<<14//0x00002000
#define NPCS1     1<<31//0x80000000
*/


void SPI_Init(void)
{

//IO0DIR |= 0xFF;
//IO0DIR &= ~(1 << 5);
//IO0CLR = 0x80;

PINSEL0=0x1500;

PCONP |= 0x100;
//VPBDIV=0x0;
SPCCR = 0x48;
  //SPCR |= (1 << 5);  //master
  SPCR = 0x20;
 //SPDR=0;
//IO0DIR |= 0xFF;
//IO0DIR &= ~(1 << 5);
//IO0CLR = 0x80;

}

unsigned char SPI_TXRX(unsigned char data)
{
  unsigned char temp;
  SPDR = data; // send data
  
  while(!(SPSR & 0x80))
  {}
  
 
  //delay(10);
  temp = SPDR & 0xff;
   
  //IO0CLR = 0x80;
  return temp;
  
}

void AT45_Reset(void)
{
  delay(100);
}

void AT45_Ready(void)
{char s;
  //SPI_TXRX(0xD7);
  
   s =  SPI_TXRX(0xd7); 
       
  while (!(s & 0x80))
  {
  s =  SPI_TXRX(0xd7);
  
  AT45_Reset();
  }
 
}

unsigned char AT45_DetectDevice(void)
{
  unsigned char temp;
  AT45_Ready(); //wait until dataflash is ready
  
  SPI_TXRX(0xD7); //check status byte
  temp = SPI_TXRX(0);
  AT45_Reset();

  return (temp>>2)&0x0f;
}

/*void AT45_ContinousArrayRead(unsigned long address, char pointer_ram[] ,unsigned long n)
{
int i;
  AT45_Ready(); //wait until dataflash is ready

  SPI_TXRX(0xE8); //send opcode

 /* SPI_TXRX((address>>16)&0xff); //send address
  SPI_TXRX((address>>8)&0xff);
  SPI_TXRX(address&0xff);
  SPDR = 0; // send data
  SPI_TXRX(0); SPI_TXRX(0); SPI_TXRX(0);

  //send don't care clocks
  //SPI_TXRX(0); SPI_TXRX(0); SPI_TXRX(0); SPI_TXRX(0);
 i=0;
  while (i<n) //read data
  {
    pointer_ram[0] = SPI_TXRX(0);
AT45_Reset();
    i++;
  }

  AT45_Reset();
}*/

void AT45_ContinousArrayRead(unsigned long address, unsigned char *pointer_ram ,unsigned long n)
{
  AT45_Ready(); //wait until dataflash is ready

  SPI_TXRX(0xE8); //send opcode

  SPI_TXRX((address>>16)&0xff); //send address
  SPI_TXRX((address>>8)&0xff);
  SPI_TXRX(address&0xff);
  SPDR=0;
  //send don't care clocks
  SPI_TXRX(0); SPI_TXRX(0); SPI_TXRX(0); SPI_TXRX(0);

  while (n--) //read data
  {
    *(pointer_ram++) = SPI_TXRX(0);
  }

  AT45_Reset();
}

void AT45_MainMemoryProgram(unsigned char buffer, unsigned long address, unsigned char *pointer_ram ,unsigned long n)
{
  AT45_Ready(); //wait until dataflash is ready

 // SPI_TXRX((buffer==1)?0x82:0x85); //send opcode
  SPI_TXRX(0x85);
  SPI_TXRX((address>>16)&0xff); //send address
  SPI_TXRX((address>>8)&0xff);
  SPI_TXRX(address&0xff);
  
  while (n--) //write data
  {
    SPI_TXRX(*(pointer_ram++)); 
  }

  AT45_Reset();
}

/*
void AT45_MainMemoryProgram(unsigned char buffer, unsigned long address, char pointer_ram[] ,unsigned long n)
{
char i;
  AT45_Ready(); //wait until dataflash is ready

 // SPI_TXRX((buffer==1)?0x82:0x85); //send opcode
SPI_TXRX(0x82);
  /*SPI_TXRX((address>>16)&0xff); //send address
  SPI_TXRX((address>>8)&0xff);
  SPI_TXRX(address&0xff);
SPI_TXRX(0); SPI_TXRX(0); SPI_TXRX(0);

  i=0;
  while (i<n) //write data
  {
    SPI_TXRX(pointer_ram[0]);
     AT45_Reset();
    i++;
  }

  AT45_Reset();
}*/

void AT45_PageErase(unsigned long address)
{
  AT45_Ready(); //wait until dataflash is ready

  SPI_TXRX(0x81); //send opcode

  address <<= 10;
  
  SPI_TXRX((address>>16)&0xff); //send address
  SPI_TXRX((address>>8)&0xff);
  SPI_TXRX(address&0xff);

  AT45_Reset();
}